﻿(function () {
    'use strict';

    function dashboardController(
        userService,
        translateSetService,
        translateJobService,
        translateNodeService) {

        var vm = this;

        vm.loading = true;
        vm.setup = false;
        vm.createSet = createSet;
        vm.hasSettings = false;

        vm.viewSets = viewSets;
        vm.viewPending = viewPending;
        vm.viewSubmitted = viewSubmitted;
        vm.viewReceived = viewReceived;

        vm.counts = {
            pending: -1,
            submitted: -1,
            received: -1
        };

        Init();

        ///////////
        function createSet() {
            window.location.href = '#/settings/tmSettings/setEdit/-1';
        }

        function viewSets() {
            window.location.href = '#/settings/tmSettings/sets';
        }

        function viewPending() {
            window.location.href = '#/translation/pending/summary';
        }

        function viewSubmitted() {
            window.location.href = '#/translation/submitted/summary';
        }

        function viewReceived() {
            window.location.href = '#/translation/received/summary';
        }


        function getjobCounts() {


            translateJobService.getSummaryCount(10, 19)
                .then(function (result) {
                    vm.counts.received = result.data;
                });

            translateJobService.getSummaryCount(1, 9)
                .then(function (result) {
                    vm.counts.submitted = result.data;
                });

            translateNodeService.getSummaryCount(0)
                .then(function (result) {
                    vm.counts.pending = result.data;
                });
        }


        function getSets() {
            translateSetService.list()
                .then(function (result) {
                    vm.sets = result.data;
                    vm.setup = vm.sets.length > 0;
                    vm.loading = false;
                });
        }


        function Init() {
            getSets();
            getjobCounts();

            userService.getCurrentUser().then(function (u) {
                vm.hasSettings = u.allowedSections.includes('settings');
            });

        }

    }

    angular.module('umbraco')
        .controller('translateDashboardController', dashboardController);
})();